<?php
///////////////////////////////////////////
// Create a link between two nodes
///////////////////////////////////////////
require_once 'easybitcoin.php';
header('Content-type: application/json');
$node = "";
error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - Iniciando createlink.php\r\n", 3, "/tmp/createlink.log");

// Obtains node to create the link from parameters
if (!isset($_GET["node"]))
{
	error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - No existe node\r\n", 3, "/tmp/createlink.log");
	echo "{ }";
	die;
}
else
{
	$node = $_GET["node"];
}
// Obtain the other node from parameters
if (!isset($_GET["othernode"]))
{
	error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - No existe othernode\r\n", 3, "/tmp/createlink.log");
	echo "{ }";
	die;
}
else
{
	$othernode = $_GET["othernode"];
}
error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - node " . $node . " othernode " . $othernode . "\r\n", 3, "/tmp/createlink.log");

//use the function addnode the easybitcoin.php module
$bitcoin = new Bitcoin('statoshidockerized', 'prueba', $node, '8332');
$bitcoin->addnode($othernode, "add");
error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - Status " . $bitcoin->status . "\r\n", 3, "/tmp/createlink.log");
error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - Response " . $bitcoin->raw_response  . "\r\n", 3, "/tmp/createlink.log");
$response = $bitcoin->response;
echo "{ }";


