<?php 
///////////////////////////////////////////
// Create a link between two nodes
///////////////////////////////////////////

header('Content-Type: application/json');
error_log("Llamada a crear nodo " . $_SERVER['QUERY_STRING'] . "\r\n", 3, "/tmp/my-errors.log");

$numNode = "";
$network = "";
// Obtains node to create the link from parameters
if (!isset($_GET["node"]))
{
	$numNode="";
}
else
{
	$numNode= $_GET["node"];
}
if (!isset($_GET["network"]))
{
	$network="walletreg";
}
else
{
	$network = $_GET["network"];
}

$imageReg = "statoshi1";
/////////////////////////////////
// Create the node call containers/create API
/////////////////////////////////
$ch = curl_init();
// set url
curl_setopt($ch, CURLOPT_URL, "http://127.0.0.1:2375/v1.24/containers/create?name=" . $network . $numNode);
$data_string = "{\"Image\": \"" . $imageReg . "\",\"Env\":[\"NODETYPE=" . $network . "\",\"NODENAME=" . $network . $numNode . "\"]}";
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array(
		'Content-Type: application/json',
		'Content-Length: ' . strlen($data_string))
		);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
$output = curl_exec($ch);
$images = json_decode($output);
// close curl resource to free up system resources
curl_close($ch);
error_log("Creado nodo main -espera" . $output . "\r\n", 3, "/tmp/my-errors.log");
sleep(1);
error_log("Creado nodo main -fin\r\n", 3, "/tmp/my-errors.log");

///////////////////////////
// Start master node
///////////////////////////
error_log("Arrancando nodo\r\n", 3, "/tmp/my-errors.log");
$ch = curl_init();	
curl_setopt($ch, CURLOPT_URL, "http://127.0.0.1:2375/v1.24/containers/" . $network . $numNode . "/start");
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array(
	'Content-Type: application/json'));
error_log("Arrancando nodo maestro - Codigo de error " . curl_errno($ch) . "\r\n", 3, "/tmp/my-errors.log");
error_log("Arrancando nodo maestro - Codigo de error 2 " . curl_errno($ch) . "\r\n", 3, "/tmp/my-errors.log");
$output = curl_exec($ch);
error_log("Arrancando nodo maestro - Codigo de error 3 " . curl_errno($ch) . "\r\n", 3, "/tmp/my-errors.log");
error_log("Retorno intento arrancar :" . $output . "\r\n", 3, "/tmp/my-errors.log");
// close curl resource to free up system resources
curl_close($ch);

////////////////////////////////////////
//  Search the IP Address of the node
////////////////////////////////////////
$ch = curl_init();
error_log("Se busca dirección IP de maestro\r\n", 3, "/tmp/my-errors.log");
curl_setopt($ch, CURLOPT_URL, "http://127.0.0.1:2375/v1.24/containers/" . $network . $numNode . "/json");
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array(
		'Content-Type: application/json',
		//'Content-Length: ' . strlen($data_string))
		)		
		);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
error_log("Se busca dirección IP - se lanza la ejecución\r\n", 3, "/tmp/my-errors.log");
$output = curl_exec($ch);
error_log("Se busca dirección IP - error " . curl_errno($ch) . "\r\n", 3, "/tmp/my-errors.log");
$data = json_decode($output);
$ipAddress="";
foreach ($data as $key => $value)
{
   if ($key == "NetworkSettings")
   {
       foreach($value as $k1 => $v1)
       {
           if ($k1 == "Networks")
           {
               foreach($v1 as $k2 => $v2)
               {
                   if ($k2 == "bridge")
                   foreach($v2 as $k3 => $v3)
                   {
                        if ($k3 == "IPAddress")
                        {
                            $ipAddress=$v3;
                        }
                   }
               }
           }
       }
   }
}
error_log("Se busca dirección IP - Ip address " . $ipAddress . "\r\n", 3, "/tmp/my-errors.log");
// close curl resource to free up system resources
curl_close($ch);

/////////////////////////////////
// Create dashboard in Grafana
/////////////////////////////////
include 'createdashboards.php';

echo "{\"node\": \"" . $ipAddress . "\"}";

?>

